// Sample flex/bison application
// main.c -- main program

// Version:
#define VERSION "1.01"

#include <iostream>

// The lexer reads input from FILE *yyin, so we need this include
#include <cstdio>
// System error information
#include <cerrno>	// for errno
#include <cstring>	// for strerror

using namespace std;

extern FILE *yyin;	// The file to read compiler source from; old "C" I/O

// yyparse is declared to have an int return value for historical
// reasons.  It's really void...
extern int /*(sic)*/ yyparse ( void );

int main( int argc, char *argv[] )
{
	// Identify ourselves
	cerr << "Desk Calculator, version " << VERSION
		<< " (" << __DATE__ << " " << __TIME__ << ")" << endl;

	// Open the input file
	if ( argc > 1 )
	{
		yyin = fopen ( argv[1], "r" );
		if ( !yyin )
		{
			// If the file didn't open, errno & strerror have
			// information about what went wrong
			cerr << "Can't open file " << argv[1] << ": "
				<< strerror(errno) << endl;
			exit ( 10 );
		}
	}
	else
		yyin = stdin;

	// Run the parser
	(void) yyparse();

	// Clean up
	if ( yyin != stdin )
		fclose ( yyin );

	return 0;
}
